//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Prototype
void ARP_Reply (char *,int *);


//Aufbau eines ARP Header
//	
//	2 BYTE Hardware Typ				|	2 BYTE Protokoll Typ	
//	1 BYTE Lnge Hardwareadresse	|	1 BYTE Lnge Protokolladresse
//	2 BYTE Operation
//	6 BYTE MAC Adresse Absender		|	4 BYTE IP Adresse Absender
//	6 BYTE MAC Adresse Empfnger	|	4 BYTE IP Adresse Empfnger	


//Diese Routine erzeugt ein ARP buffer
void ARP_Reply (char *buffer,int *bufferlen)
{
	//Das Erzeugte buffer ist 60 Byte Lang
	*bufferlen = 0x0040;


	//MAC Destadresse wird geschrieben mit MAC Sourceadresse
	//das buffer soll ja zurckgeschickt werden :-)
	//das mache ich in einer schleife fr alle 6 Byte
	for(int a = 0; a < 6; a++)
		{
		buffer[ENETPACKETDEST0+a] = buffer[ENETPACKETSRC0+a];
		}

	//Meine MAC Adresse wird in Sourceadresse geschrieben
	//das mache ich in einer schleife fr alle 6 Byte
	for(int a=0; a<6; a++)
		{
		buffer[ENETPACKETSRC0+a] = mymac[a];
		}

	//ARP operation wird auf 2 gesetzt damit der andere merkt es ist ein ECHO	
	buffer[ARP_OP+1] = 0x02;
	
	//das gleiche fr die MAC Adresse
	//ARP MAC Targetadresse wird geschrieben mit ARP Sourceadresse
	//das mache ich in einer schleife fr alle 6 Byte
	for(int a=0; a<6; a++)
		{
		buffer[ARP_THADDR+a] = buffer[ENETPACKETDEST0+a];
		}

	//ARP Target IP Adresse wird geschrieben mit ARP Source IP Adresse 
	//das mache ich in einer schleife fr alle 4 Byte
	for(int a=0; a<4; a++)
		{
		buffer[ARP_TIPADDR+a] = buffer[ARP_SIPADDR+a];
		}
		
	//ARP MAC Sourceadresse wird geschrieben mit My MAC Adresse
	//das mache ich in einer schleife fr alle 6 Byte
	for(int a=0; a<6; a++)
		{
		buffer[ARP_SHADDR+a] = mymac[a];
		}

	//Meine IP Adresse wird in ARP Source IP Adresse geschrieben
	//das mache ich in einer schleife fr alle 4 Byte
	for(int a=0; a<4; a++)
		{
		buffer[ARP_SIPADDR+a] = MYIP[a];
		}

	//Die restlichen Bytes werden mit 20 beschrieben damit ich die 
	//minimale lnge erhalte
	for(int a=4; a<0x16; a++)
		{
		buffer[ARP_TIPADDR+a] =0x20;
		}

	//Nun ist das ARP buffer fertig zum Senden !!!
	
	//Sendet das erzeugte ARP Packet 
	Write_Ethernet_Frame (buffer,*bufferlen);
}
