//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben    		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Prototype
void ICMP_Reply (char *,int);

//Aufbau einer ICMP Nachricht
//	
//8 BIT Typ	|8 BIT Code	|16 BIT Prfsumme	
//Je nach Typ			|Nachricht unterschiedlich
//Testdaten
//
//8 BIT Typ = 0 Echo Reply oder 8 Echo request	


//Diese Routine erzeugt ein ICMP Packet
void ICMP_Reply (char *buffer,int bufferlen)
{
	//Variablen zur Berechnung der Checksumme
	unsigned int result16;
	
	//Das ist ein Echo Reply Packet
	buffer[ICMP_TYPE]=0x00;
	buffer[ICMP_CODE]=0x00;

	//Berechnung der ICMP Checksumme
	//Alle Daten im ICMP Header werden addiert checksum wird deshalb
	//ersteinmal auf null gesetzt
	buffer[ICMP_CKSUM]=0x00;
	buffer[ICMP_CKSUM+1]=0x00;

	//Hier wird erstmal der IP Header neu erstellt
	ip(buffer);

	//Berechnung der ICMP Header lnge
	result16 = ((buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1]) - ((buffer[IP_VERS_LEN] & 0x0F) << 2);

	//pointer wird auf das erste Packet im ICMP Header gesetzt
	//jetzt wird die Checksumme berechnet
	result16 = checksum (&buffer[ICMP_TYPE], result16, 0);

	//schreibt checksum ins packet (INT H Byte)
	buffer[ICMP_CKSUM] = ((result16 & 0xFF00) >> 8);

	//schreibt checksum ins packet (INT L Byte)
	buffer[ICMP_CKSUM+1] = (result16 & 0x00FF);
	
	
	//Sendet das erzeugte ICMP Packet 
	Write_Ethernet_Frame (buffer,bufferlen);
}
